diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/DoRevokeTPS.java b/pki/base/common/src/com/netscape/cms/servlet/cert/DoRevokeTPS.java
index ce074a0513b17db3198e0d97e9dfd3897df63d80..1209366133f18352859d1250476d3dc11e55b121 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/DoRevokeTPS.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/DoRevokeTPS.java
@@ -355,8 +355,8 @@ public class DoRevokeTPS extends CMSServlet {
 
         try {
             int count = 0;
-            Vector oldCertsV = new Vector();
-            Vector revCertImplsV = new Vector();
+            Vector<X509CertImpl> oldCertsV = new Vector<X509CertImpl>();
+            Vector<RevokedCertImpl> revCertImplsV = new Vector<RevokedCertImpl>();
 
             // Construct a CRL reason code extension.
             RevocationReason revReason = RevocationReason.fromInt(reason);
@@ -379,7 +379,7 @@ public class DoRevokeTPS extends CMSServlet {
                 entryExtn.set(invalidityDateExtn.getName(), invalidityDateExtn);
             }
 
-            Enumeration e = mCertDB.searchCertificates(revokeAll,
+            Enumeration<ICertRecord> e = mCertDB.searchCertificates(revokeAll,
                     totalRecordCount, mTimeLimits);
 
             boolean alreadyRevokedCertFound = false;
@@ -632,7 +632,7 @@ public class DoRevokeTPS extends CMSServlet {
 
                 if (mAuthority instanceof ICertificateAuthority) {
                     // let known update and publish status of all crls. 
-                    Enumeration otherCRLs = 
+                    Enumeration<ICRLIssuingPoint> otherCRLs = 
                         ((ICertificateAuthority) mAuthority).getCRLIssuingPoints();
 
                     while (otherCRLs.hasMoreElements()) {
@@ -717,7 +717,7 @@ public class DoRevokeTPS extends CMSServlet {
                     o_status = "status=2";
                     errorString = "error=Undefined request status";
                 }
-                Vector errors = revReq.getExtDataInStringVector(IRequest.ERRORS);
+                Vector<String> errors = revReq.getExtDataInStringVector(IRequest.ERRORS);
                 if (errors != null) {
                     StringBuffer errInfo = new StringBuffer();
 
diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/EnrollServlet.java b/pki/base/common/src/com/netscape/cms/servlet/cert/EnrollServlet.java
index 4688406ad67a5d11a1c9ec39d08ef1d44a92ef26..44d0c509778aa063b64aa6aa6fb0fa5f5b1c0821 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/EnrollServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/EnrollServlet.java
@@ -471,7 +471,7 @@ public class EnrollServlet extends CMSServlet {
         ICertRecordList list =
             (ICertRecordList) mCa.getCertificateRepository().findCertRecordsInList(filter, null, 10);
         int size = list.getSize();
-        Enumeration en = list.getCertRecords(0, size - 1);
+        Enumeration<ICertRecord> en = list.getCertRecords(0, size - 1);
         boolean gotEncCert = false;
 
         CMS.debug("EnrollServlet: signing cert filter " + filter);
@@ -573,10 +573,10 @@ public class EnrollServlet extends CMSServlet {
             // audit log the status
             try {
                 if (status == RequestStatus.REJECTED) {
-                    Vector messages = req.getExtDataInStringVector(IRequest.ERRORS);
+                    Vector<String> messages = req.getExtDataInStringVector(IRequest.ERRORS);
 
                     if (messages != null) {
-                        Enumeration msgs = messages.elements();
+                        Enumeration<String> msgs = messages.elements();
                         StringBuffer wholeMsg = new StringBuffer();
 
                         while (msgs.hasMoreElements()) {
diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/HashEnrollServlet.java b/pki/base/common/src/com/netscape/cms/servlet/cert/HashEnrollServlet.java
index 645cb831b322ba7d2a879c665bc57e47fb6ea307..5507cadf264dd0a574e8e272b39507edd4d4d6f8 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/HashEnrollServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/HashEnrollServlet.java
@@ -495,7 +495,7 @@ public class HashEnrollServlet extends CMSServlet {
                     (ICertRecordList) mCa.getCertificateRepository().findCertRecordsInList(filter,
                         null, 10);
                 int size = list.getSize();
-                Enumeration en = list.getCertRecords(0, size - 1);
+                Enumeration<ICertRecord> en = list.getCertRecords(0, size - 1);
                 boolean gotEncCert = false;
 
                 if (!en.hasMoreElements()) {
@@ -658,10 +658,10 @@ public class HashEnrollServlet extends CMSServlet {
             // audit log the status 
             try {
                 if (status == RequestStatus.REJECTED) {
-                    Vector messages = req.getExtDataInStringVector(IRequest.ERRORS);
+                    Vector<String> messages = req.getExtDataInStringVector(IRequest.ERRORS);
 
                     if (messages != null) {
-                        Enumeration msgs = messages.elements();
+                        Enumeration<String> msgs = messages.elements();
                         StringBuffer wholeMsg = new StringBuffer();
 
                         while (msgs.hasMoreElements()) {
@@ -1207,7 +1207,7 @@ public class HashEnrollServlet extends CMSServlet {
                     continue;
                 }
                 KeyUsageExtension ext = (KeyUsageExtension)
-                    exts.get(KeyUsageExtension.NAME);
+                    exts.get(KeyUsageExtension.class.getSimpleName());
 
                 if (ext == null) 
                     // should not happen 
@@ -1239,8 +1239,8 @@ public class HashEnrollServlet extends CMSServlet {
                         new KeyUsageExtension(Boolean.valueOf(true), 
                             (Object) newvalue);
 
-                    exts.delete(KeyUsageExtension.NAME);
-                    exts.set(KeyUsageExtension.NAME, newext);
+                    exts.delete(KeyUsageExtension.class.getSimpleName());
+                    exts.set(KeyUsageExtension.class.getSimpleName(), newext);
                 }
             } catch (IOException e) {
                 // should never happen 
diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/ListCerts.java b/pki/base/common/src/com/netscape/cms/servlet/cert/ListCerts.java
index f683a83d62496b9e8795f258c93f173bae71090b..a65be25a9b397bc59a6af7f0acd1d2d3da0b2136 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/ListCerts.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/ListCerts.java
@@ -70,10 +70,8 @@ public class ListCerts extends CMSServlet {
      */
     private static final long serialVersionUID = -3568155814023099576L;
     private final static String TPL_FILE = "queryCert.template";
-    private final static String INFO = "ListCerts";
     private final static BigInteger MINUS_ONE = new BigInteger("-1");
 
-    private final static String CURRENT_TIME = "currentTime";
     private final static String USE_CLIENT_FILTER = "useClientFilter";
     private final static String ALLOWED_CLIENT_FILTERS = "allowedClientFilters";
 
@@ -84,7 +82,7 @@ public class ListCerts extends CMSServlet {
     private boolean  mHardJumpTo = false; //jump to the end
     private String mDirection = null;
     private boolean mUseClientFilter = false;
-    private Vector mAllowedClientFilters = new Vector();
+    private Vector<String> mAllowedClientFilters = new Vector<String>();
     private int mMaxReturns = 2000;
 
     /**
@@ -150,7 +148,7 @@ public class ListCerts extends CMSServlet {
 
         if (mUseClientFilter) {
             com.netscape.certsrv.apps.CMS.debug("useClientFilter=true");
-            Enumeration filters = mAllowedClientFilters.elements();
+            Enumeration<String> filters = mAllowedClientFilters.elements();
             // check to see if the filter is allowed
             while (filters.hasMoreElements()) {
                 String filter = (String)filters.nextElement();
@@ -392,7 +390,7 @@ public class ListCerts extends CMSServlet {
 	       pSize);
         // retrive maxCount + 1 entries
 
-        Enumeration e = list.getCertRecords(0, maxCount); 
+        Enumeration<ICertRecord> e = list.getCertRecords(0, maxCount); 
 
         ICertRecordList tolist = null;
         int toCurIndex = 0;
@@ -404,7 +402,7 @@ public class ListCerts extends CMSServlet {
                         filter, 
                         (String[]) null, serialTo, 
                         "serialno", maxCount);
-            Enumeration en = tolist.getCertRecords(0, 0);
+            Enumeration<ICertRecord> en = tolist.getCertRecords(0, 0);
 
             if (en == null || (!en.hasMoreElements())) {
                 toCurIndex = list.getSize() - 1;
@@ -650,7 +648,7 @@ public class ListCerts extends CMSServlet {
                 CRLExtensions crlExts = revocationInfo.getCRLEntryExtensions();
 
                 if (crlExts != null) {
-                    Enumeration enum1 = crlExts.getElements();
+                    Enumeration<Extension> enum1 = crlExts.getElements();
                     int reason = 0;
 
                     while (enum1.hasMoreElements()) {
diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/SrchCerts.java b/pki/base/common/src/com/netscape/cms/servlet/cert/SrchCerts.java
index 84e7e784a27ed2e5e0016e5a477658944a71d67a..17bad7a1ef42cf8d5cb96d6fb5453bba8b21d48f 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/SrchCerts.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/SrchCerts.java
@@ -629,12 +629,12 @@ public class SrchCerts extends CMSServlet {
                 timeLimit = mTimeLimits;
             }
             CMS.debug("Start searching ... " + "filter=" + filter + " maxreturns=" + maxResults + " timelimit=" + timeLimit);
-            Enumeration e = mCertDB.searchCertificates(filter, maxResults, timeLimit);
+            Enumeration<ICertRecord > e = mCertDB.searchCertificates(filter, maxResults, timeLimit);
 
             int count = 0;
 
             while (e != null && e.hasMoreElements()) {
-                ICertRecord rec = (ICertRecord) e.nextElement();
+                ICertRecord rec = e.nextElement();
 
                 if (rec != null) {
                     count++;
@@ -761,11 +761,11 @@ public class SrchCerts extends CMSServlet {
                 CRLExtensions crlExts = revocationInfo.getCRLEntryExtensions();
 
                 if (crlExts != null) {
-                    Enumeration enum1 = crlExts.getElements();
+                    Enumeration<Extension> enum1 = crlExts.getElements();
                     int reason = 0;
 
                     while (enum1.hasMoreElements()) {
-                        Extension ext = (Extension) enum1.nextElement();
+                        Extension ext = enum1.nextElement();
 
                         if (ext instanceof CRLReasonExtension) {
                             reason = ((CRLReasonExtension) ext).getReason().toInt();
diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/UpdateCRL.java b/pki/base/common/src/com/netscape/cms/servlet/cert/UpdateCRL.java
index 396f333bcc114d9698cac2f4807f8bfed0d68000..b10086e160f6113e0c6b6242f8e72d272e616074 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/UpdateCRL.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/UpdateCRL.java
@@ -51,6 +51,7 @@ import com.netscape.certsrv.ca.ICertificateAuthority;
 import com.netscape.certsrv.ldap.ELdapException;
 import com.netscape.certsrv.logging.AuditFormat;
 import com.netscape.certsrv.logging.ILogger;
+import com.netscape.certsrv.publish.ILdapRule;
 import com.netscape.certsrv.publish.IPublisherProcessor;
 import com.netscape.certsrv.util.IStatsSubsystem;
 import com.netscape.cms.servlet.base.CMSServlet;
@@ -74,7 +75,7 @@ public class UpdateCRL extends CMSServlet {
     private final static String INFO = "UpdateCRL";
     private final static String TPL_FILE = "updateCRL.template";
 
-    private static Vector mTesting = new Vector();
+    private static Vector<String> mTesting = new Vector<String>();
 
     private String mFormPath = null;
     private ICertificateAuthority mCA = null;
@@ -280,7 +281,7 @@ public class UpdateCRL extends CMSServlet {
         rarg.addStringValue("crlSizes", crlSizes);
 
         StringBuffer crlSplits = new StringBuffer();
-        Vector splits = crlIssuingPoint.getSplitTimes();
+        Vector<Long> splits = crlIssuingPoint.getSplitTimes();
         for (int i = 0; i < splits.size(); i++) {
             crlSplits.append(splits.elementAt(i));
             if (i + 1 < splits.size())
@@ -313,10 +314,10 @@ public class UpdateCRL extends CMSServlet {
         String results = req.getParameter("results");
 
         if (crlIssuingPointId != null) {
-            Enumeration ips = mCA.getCRLIssuingPoints();
+            Enumeration<ICRLIssuingPoint> ips = mCA.getCRLIssuingPoints();
 
             while (ips.hasMoreElements()) {
-                ICRLIssuingPoint ip = (ICRLIssuingPoint) ips.nextElement();
+                ICRLIssuingPoint ip =  ips.nextElement();
 
                 if (crlIssuingPointId.equals(ip.getId())) {
                     break;
@@ -448,7 +449,7 @@ public class UpdateCRL extends CMSServlet {
                         }
 
                         if (lpm != null && lpm.enabled()) {
-                            Enumeration rules = lpm.getRules(IPublisherProcessor.PROP_LOCAL_CRL);
+                            Enumeration<ILdapRule> rules = lpm.getRules(IPublisherProcessor.PROP_LOCAL_CRL);
                             if (rules != null && rules.hasMoreElements()) {
                                 if (publishError != null) {
                                     header.addStringValue("crlPublished", "Failure");
diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/scep/CRSEnrollment.java b/pki/base/common/src/com/netscape/cms/servlet/cert/scep/CRSEnrollment.java
index 19714cbfaf52fbac4e8b2accc00a8df8188b9814..f181e1567133f4ed5403afd925a532305c4167d0 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/scep/CRSEnrollment.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/scep/CRSEnrollment.java
@@ -208,9 +208,10 @@ protected IProfileSubsystem     mProfileSubsystem = null;
 
   public CRSEnrollment(){}
 
-  public static Hashtable toHashtable(HttpServletRequest req) {
-       Hashtable httpReqHash = new Hashtable();
-       Enumeration names = req.getParameterNames();
+  public static Hashtable<String, String> toHashtable(HttpServletRequest req) {
+       Hashtable<String, String> httpReqHash = new Hashtable<String, String>();
+       @SuppressWarnings("unchecked")
+	Enumeration<String> names = req.getParameterNames();
        while (names.hasMoreElements()) {
                String name = (String)names.nextElement();
                httpReqHash.put(name, req.getParameter(name));
@@ -431,7 +432,7 @@ protected IProfileSubsystem     mProfileSubsystem = null;
         HttpServletRequest request)  throws EBaseException {
 
         // build credential
-        Enumeration authNames = authenticator.getValueNames();
+        Enumeration<String> authNames = authenticator.getValueNames();
 
         if (authNames != null) {
             while (authNames.hasMoreElements()) {
@@ -554,7 +555,7 @@ protected IProfileSubsystem     mProfileSubsystem = null;
   public String getPasswordFromP10(PKCS10 p10) 
   {
      PKCS10Attributes p10atts = p10.getAttributes();
-     Enumeration e = p10atts.getElements();
+     Enumeration<PKCS10Attribute> e = p10atts.getElements();
               
      try {
        while (e.hasMoreElements()) {
@@ -707,7 +708,7 @@ protected IProfileSubsystem     mProfileSubsystem = null;
 
           String pkcs10Attr = "";
               PKCS10Attributes p10atts = p10.getAttributes();
-              Enumeration e = p10atts.getElements();
+              Enumeration<PKCS10Attribute> e = p10atts.getElements();
               
               while (e.hasMoreElements()) {
                   PKCS10Attribute p10a = (PKCS10Attribute)e.nextElement();
@@ -724,9 +725,9 @@ protected IProfileSubsystem     mProfileSubsystem = null;
                   String extensionsStr = "";
                   if (attr.getName().equals(ExtensionsRequested.NAME)) {
 
-					Enumeration exts = ((ExtensionsRequested)attr).getExtensions().elements();
+					Enumeration<Extension> exts = ((ExtensionsRequested)attr).getExtensions().elements();
 					while (exts.hasMoreElements()) {
-						Extension ext = (Extension) exts.nextElement();
+						Extension ext =  exts.nextElement();
 
 						if (ext.getExtensionId().equals(
 							OIDMap.getOID(SubjectAlternativeNameExtension.IDENT)) ) {
@@ -736,14 +737,15 @@ protected IProfileSubsystem     mProfileSubsystem = null;
 									ext.getExtensionValue());
 
 								
-							Vector v = 
-                              (Vector) sane.get(SubjectAlternativeNameExtension. SUBJECT_NAME);
+							@SuppressWarnings("unchecked")
+							Vector<GeneralNameInterface> v = 
+                              (Vector<GeneralNameInterface>) sane.get(SubjectAlternativeNameExtension. SUBJECT_NAME);
 
-							Enumeration gne = v.elements();
+							Enumeration<GeneralNameInterface> gne = v.elements();
 
                             StringBuffer subjAltNameStr = new StringBuffer();
 							while (gne.hasMoreElements()) {
-								GeneralNameInterface gni = (GeneralNameInterface) gne.nextElement();
+								GeneralNameInterface gni =  gne.nextElement();
 								if (gni instanceof GeneralName) {
 									GeneralName genName = (GeneralName) gni;
 
@@ -1009,12 +1011,12 @@ protected IProfileSubsystem     mProfileSubsystem = null;
       IRequestQueue rq  = ca.getRequestQueue();
       IRequest foundRequest = null;
 
-      Enumeration rids    = rq.findRequestsBySourceId(txid);
+      Enumeration<RequestId> rids    = rq.findRequestsBySourceId(txid);
 	  if (rids == null) { return null; }
 
       int count=0;
       while (rids.hasMoreElements()) {
-			RequestId rid = (RequestId) rids.nextElement();
+			RequestId rid =  rids.nextElement();
 			if (rid == null) {
 				continue;
 			}
@@ -1194,12 +1196,11 @@ private void getDetailFromRequest(CRSPKIMessage req, CRSPKIMessage crsResp)
 
       IRequest issueReq = null;
       X509CertImpl issuedCert=null;
-      Vector extensionsRequested = null;
       SubjectAlternativeNameExtension sane = null;
       CertAttrSet requested_ext = null;
 
       try {
-             PKCS10 p10 = (PKCS10)req.getP10();
+             PKCS10 p10 = req.getP10();
 
              if (p10 == null) {
 			     crsResp.setFailInfo(CRSPKIMessage.mFailInfo_badMessageCheck);
@@ -1228,10 +1229,10 @@ private void getDetailFromRequest(CRSPKIMessage req, CRSPKIMessage crsResp)
               //   one RDN, with many AVA's    to
               //   many RDN's with one AVA in each.
 
-              Enumeration rdne     = p10subject.getRDNs();
-              Vector      rdnv = new Vector();
+              Enumeration<RDN> rdne     = p10subject.getRDNs();
+              Vector<RDN>      rdnv = new Vector<RDN>();
 
-			  Hashtable sanehash = new Hashtable();
+			  Hashtable<String, String> sanehash = new Hashtable<String, String>();
 
               X500NameAttrMap xnap = X500NameAttrMap.getDefault();
               while (rdne.hasMoreElements()) {
@@ -1271,7 +1272,7 @@ private void getDetailFromRequest(CRSPKIMessage req, CRSPKIMessage crsResp)
 
 
               PKCS10Attributes p10atts = p10.getAttributes();
-              Enumeration e = p10atts.getElements();
+              Enumeration<PKCS10Attribute> e = p10atts.getElements();
               
               while (e.hasMoreElements()) {
                   PKCS10Attribute p10a = (PKCS10Attribute)e.nextElement();
@@ -1290,9 +1291,9 @@ private void getDetailFromRequest(CRSPKIMessage req, CRSPKIMessage crsResp)
                   
                   if (attr.getName().equals(ExtensionsRequested.NAME)) {
 
-					Enumeration exts = ((ExtensionsRequested)attr).getExtensions().elements();
+					Enumeration<Extension> exts = ((ExtensionsRequested)attr).getExtensions().elements();
 					while (exts.hasMoreElements()) {
-						Extension ext = (Extension) exts.nextElement();
+						Extension ext = exts.nextElement();
 
 						if (ext.getExtensionId().equals(
 							OIDMap.getOID(KeyUsageExtension.IDENT)) ) {
@@ -1310,10 +1311,11 @@ private void getDetailFromRequest(CRSPKIMessage req, CRSPKIMessage crsResp)
 									ext.getExtensionValue());
 
 								
-							Vector v = 
-                              (Vector) sane.get(SubjectAlternativeNameExtension. SUBJECT_NAME);
+							@SuppressWarnings("unchecked")
+							Vector<GeneralNameInterface> v =
+									(Vector<GeneralNameInterface>) sane.get(SubjectAlternativeNameExtension. SUBJECT_NAME);
 
-							Enumeration gne = v.elements();
+							Enumeration<GeneralNameInterface> gne = v.elements();
 
 							while (gne.hasMoreElements()) {
 								GeneralNameInterface gni = (GeneralNameInterface) gne.nextElement();
@@ -1376,12 +1378,12 @@ private void getDetailFromRequest(CRSPKIMessage req, CRSPKIMessage crsResp)
               CertificateExtensions ext = new CertificateExtensions();
 
               if (kue != null) {
-                  ext.set(KeyUsageExtension.NAME, kue);
+                  ext.set(KeyUsageExtension.class.getSimpleName(), kue);
               }
 
               // add subjectAltName extension, if present
               if (sane != null) {
-                  ext.set(SubjectAlternativeNameExtension.NAME, sane);
+                  ext.set(SubjectAlternativeNameExtension.class.getSimpleName(), sane);
               }
 
               certInfo.set(X509CertInfo.EXTENSIONS,ext);
@@ -1395,7 +1397,7 @@ private void getDetailFromRequest(CRSPKIMessage req, CRSPKIMessage crsResp)
   }
                   
 
-  private SubjectAlternativeNameExtension makeDefaultSubjectAltName(Hashtable ht) {
+  private SubjectAlternativeNameExtension makeDefaultSubjectAltName(Hashtable<String, String> ht) {
 
     // if no subjectaltname extension was requested, we try to make it up
     // from some of the elements of the subject name
@@ -1404,7 +1406,7 @@ private void getDetailFromRequest(CRSPKIMessage req, CRSPKIMessage crsResp)
 	GeneralNameInterface[] gn = new GeneralNameInterface[ht.size()];
 
 	itemCount = 0;
-	Enumeration en = ht.keys();
+	Enumeration<String> en = ht.keys();
     while (en.hasMoreElements()) {
 		String key = (String) en.nextElement();
 		if (key.equals(SANE_DNSNAME)) {
@@ -1495,10 +1497,10 @@ private void getDetailFromRequest(CRSPKIMessage req, CRSPKIMessage crsResp)
          return authenticationFailed;
    }
 
-  private boolean areFingerprintsEqual(IRequest req, Hashtable fingerprints)
+  private boolean areFingerprintsEqual(IRequest req, Hashtable<String, byte[]> fingerprints)
   {
 	
-	Hashtable old_fprints = req.getExtDataInHashtable(IRequest.FINGERPRINTS);
+	Hashtable<String, Object> old_fprints = req.getExtDataInHashtable(IRequest.FINGERPRINTS);
 	if (old_fprints == null) { return false; }
 
     byte[] old_md5 = CMS.AtoB((String) old_fprints.get("MD5"));
@@ -1521,7 +1523,7 @@ private void getDetailFromRequest(CRSPKIMessage req, CRSPKIMessage crsResp)
 
 	try {
        unwrapPKCS10(req,cx);
-	   Hashtable fingerprints = makeFingerPrints(req);
+	   Hashtable<String, byte[]> fingerprints = makeFingerPrints(req);
 
        if (cmsRequest != null) {
 			if (areFingerprintsEqual(cmsRequest, fingerprints)) {
@@ -1614,7 +1616,7 @@ throws EBaseException {
 
      // use profile framework to handle SCEP
      if (mProfileId != null) {
-       PKCS10 pkcs10data = (PKCS10)req.getP10();
+       PKCS10 pkcs10data = req.getP10();
        String pkcs10blob = CMS.BtoA(pkcs10data.toByteArray());
 
        // XXX authentication handling
@@ -1726,10 +1728,10 @@ throws EBaseException {
 	 } catch (Exception pwex) {
 	 }
 
-     Hashtable fingerprints = (Hashtable)req.get(IRequest.FINGERPRINTS);
+     Hashtable<?, ?> fingerprints = (Hashtable<?, ?>)req.get(IRequest.FINGERPRINTS);
      if (fingerprints.size() > 0) {
-         Hashtable encodedPrints = new Hashtable(fingerprints.size());
-         Enumeration e = fingerprints.keys();
+         Hashtable<String, String> encodedPrints = new Hashtable<String, String>(fingerprints.size());
+         Enumeration<?> e = fingerprints.keys();
          while (e.hasMoreElements()) {
              String key = (String)e.nextElement();
              byte[] value = (byte[])fingerprints.get(key);
@@ -1761,8 +1763,8 @@ throws EBaseException {
 
 
 
-  public Hashtable makeFingerPrints(CRSPKIMessage req) {
-        Hashtable fingerprints = new Hashtable();
+  public Hashtable<String, byte[]> makeFingerPrints(CRSPKIMessage req) {
+        Hashtable<String, byte[]> fingerprints = new Hashtable<String, byte[]>();
 
         MessageDigest md;
         String[] hashes = new String[] {"MD2", "MD5", "SHA1", "SHA256", "SHA512"};
@@ -2020,7 +2022,7 @@ throws EBaseException {
     private CryptoToken keyStorageToken;
     private CryptoToken internalKeyStorageToken;
     private KeyGenerator DESkg;
-	private Enumeration externalTokens = null;
+	private Enumeration<?> externalTokens = null;
     private org.mozilla.jss.crypto.X509Certificate signingCert;
     private org.mozilla.jss.crypto.PrivateKey signingCertPrivKey;
 	private int signingCertKeySize = 0;
@@ -2118,11 +2120,11 @@ throws EBaseException {
         return internalToken;
     }
 
-    public void setExternalTokens( Enumeration tokens ) {
+    public void setExternalTokens( Enumeration<?> tokens ) {
         externalTokens = tokens;
     }
 
-    public Enumeration getExternalTokens() {
+    public Enumeration<?> getExternalTokens() {
         return externalTokens;
     }
 
diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/scep/ChallengePassword.java b/pki/base/common/src/com/netscape/cms/servlet/cert/scep/ChallengePassword.java
index b449a8bd88a3d94704ed4bc77be27970d1b64edc..49a591f07092a06ad4c8872f68d4c0caab9b7570 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/scep/ChallengePassword.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/scep/ChallengePassword.java
@@ -23,7 +23,7 @@ import java.io.InputStream;
 import java.io.OutputStream;
 import java.security.cert.CertificateException;
 import java.util.Enumeration;
-import java.util.Hashtable;
+import java.util.Vector;
 
 import netscape.security.util.DerValue;
 import netscape.security.x509.CertAttrSet;
@@ -130,8 +130,8 @@ public class ChallengePassword implements CertAttrSet {
   /**
    * @return an empty set of elements
    */
-  public Enumeration getElements()
-    { return (new Hashtable()).elements();}
+  public Enumeration<String> getAttributeNames()
+    { return (new Vector<String>()).elements();}
 
   /**
    * @return the String "ChallengePassword"
diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/scep/ExtensionsRequested.java b/pki/base/common/src/com/netscape/cms/servlet/cert/scep/ExtensionsRequested.java
index a8757e74f23ee758bf24a4e8cffd006003d325a5..6f689b341f93148cccf54a46d589dde2b37e2b6e 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/scep/ExtensionsRequested.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/scep/ExtensionsRequested.java
@@ -23,7 +23,6 @@ import java.io.InputStream;
 import java.io.OutputStream;
 import java.security.cert.CertificateException;
 import java.util.Enumeration;
-import java.util.Hashtable;
 import java.util.Vector;
 
 import netscape.security.util.DerInputStream;
@@ -43,7 +42,7 @@ public class ExtensionsRequested implements CertAttrSet {
     private String kue_digital_signature = "false";
     private String kue_key_encipherment  = "false";
     
-    private Vector exts = new Vector();
+    private Vector<Extension> exts = new Vector<Extension>();
 
     public ExtensionsRequested(Object stuff) throws IOException {
         ByteArrayInputStream is = new ByteArrayInputStream((byte[]) stuff);
@@ -91,8 +90,8 @@ public class ExtensionsRequested implements CertAttrSet {
     { 
     }
 
-    public Enumeration getElements()
-    { return (new Hashtable()).elements();}
+    public Enumeration<String> getAttributeNames()
+    { return (new Vector<String>()).elements();}
     
     public String getName()
     { return NAME;}
@@ -182,7 +181,7 @@ public class ExtensionsRequested implements CertAttrSet {
 
     }
 
-	public Vector getExtensions() {
+	public Vector<Extension> getExtensions() {
 		return exts;
 	}
 
diff --git a/pki/base/common/src/com/netscape/cms/servlet/common/CMCOutputTemplate.java b/pki/base/common/src/com/netscape/cms/servlet/common/CMCOutputTemplate.java
index 03cb83f63b5a841439e511e02cf3c8d235d21f58..3fac4a63719f1b12130729c6b341027b236c89ed 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/common/CMCOutputTemplate.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/common/CMCOutputTemplate.java
@@ -1032,7 +1032,7 @@ public class CMCOutputTemplate {
 
             SET dias = msgData.getDigestAlgorithmIdentifiers();
             int numDig = dias.size();
-            Hashtable digs = new Hashtable();
+            Hashtable<String, byte[]> digs = new Hashtable<String, byte[]>();
             for (int i=0; i<numDig; i++) {
                 AlgorithmIdentifier dai =
                   (AlgorithmIdentifier) dias.elementAt(i);
@@ -1050,7 +1050,7 @@ public class CMCOutputTemplate {
                 org.mozilla.jss.pkix.cms.SignerInfo si =
                   (org.mozilla.jss.pkix.cms.SignerInfo)sis.elementAt(i);
                 String name = si.getDigestAlgorithm().toString();
-                byte[] digest = (byte[]) digs.get(name);
+                byte[] digest = digs.get(name);
                 if (digest == null) {
                     MessageDigest md = MessageDigest.getInstance(name);
                     ByteArrayOutputStream ostream = new ByteArrayOutputStream();
diff --git a/pki/base/common/src/com/netscape/cms/servlet/connector/ConnectorServlet.java b/pki/base/common/src/com/netscape/cms/servlet/connector/ConnectorServlet.java
index ad48d18d9d5f0fd4c58d63924ac155d33a9831b2..67956bd8ac74938ac027532779f7d95fee738b1c 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/connector/ConnectorServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/connector/ConnectorServlet.java
@@ -836,10 +836,10 @@ public class ConnectorServlet extends CMSServlet {
                         int reason = 0;
 
                         if (crlExts != null) {
-                            Enumeration enum1 = crlExts.getElements();
+                            Enumeration<Extension> enum1 = crlExts.getElements();
 
                             while (enum1.hasMoreElements()) {
-                                Extension ext = (Extension) enum1.nextElement();
+                                Extension ext =  enum1.nextElement();
 
                                 if (ext instanceof CRLReasonExtension) {
                                     reason = ((CRLReasonExtension) ext).getReason().toInt();
